--this is the button class, as you can tell, opt3D is in here, it will be gone in V3 so we can just implement it in a "Style Pack"
button = class()

--Create and init the button
function button:init(text, x, y, action, txtcolor, bgcolor, opt3D, parent)
    self.text = text
    self.parent = parent
	self.x = x + parent.x
    self.y = y + parent.y
	self.xoff = x
	self.yoff = y
    self.action = action
    self.labelwidth = 0
    self.width = 0
    self.height = 20
	self.txtcolor = txtcolor
	self.bgcolor = bgcolor
	self.opt3D = opt3D
    table.insert(parent.controls, self)
end

--Draw the button
function button:paint(gc)
	if not(self.opt3D) then
		gc:setFont("sansserif", "b", 12)
		self.labelwidth = gc:getStringWidth(self.text)
		self.width = self.labelwidth + 6
		gc:setColorRGB(unpack(self.bgcolor))
		gc:fillRect(self.x, self.y, self.width, self.height)
		gc:setColorRGB(unpack(color.black))
		gc:setPen("thin", "smooth")
		gc:drawRect(self.x, self.y, self.width, self.height)
		gc:setColorRGB(unpack(self.txtcolor))
		gc:drawString(self.text, self.x + 2, self.y - 1, "top")
	else
		gc:setFont("sansserif", "b", 12)
		self.labelwidth = gc:getStringWidth(self.text)
		self.width = self.labelwidth + 6
		gc:setColorRGB( unpack(self.bgcolor))
		gc:fillRect(self.x - 2, self.y - 2, self.width + 2, self.height + 2)
		gc:setColorRGB(unpack(color.black))
		gc:setPen("thin", "smooth")
		gc:drawRect(self.x, self.y, self.width, self.height)
		gc:drawLine(self.x, self.y, self.x - 2, self.y - 2)
		gc:drawRect(self.x - 2, self.y - 2, self.width + 2, self.height + 2)
		gc:setColorRGB(unpack(self.txtcolor))
		gc:drawString(self.text, self.x + 2, self.y - 1, "top")
	end
end


function button:click()
	self.action()
end

function button:checkClick(x, y)
	if y >= self.y and y <= self.y + self.height and x >= self.x and x <= self.x + self.width then
		self:click()
	end
end
