--This is context menu. it goes hand in hand with forms and should only be used with forms, even though tecnicaly you could use it elsewhere
--they now dynamicly determine the width of an open menu, so you can have large or small text and are not limited to 35 pixles
contextm = class()

function contextm:init(parent, cmtable)
	self.parent = parent
	self.x = parent.x
	self.y = parent.y
	self.cmtable = cmtable
	self.width = parent.width
	self.selected = false
	self.menOpen = false
	self.selectedMenu = nil
	table.insert(parent.controls, table.maxn(parent.controls), self)
end
function contextm:paint(gc)
	gc:setFont("sansserif", "r", 6)
	gc:setColorRGB(unpack(color.black))
	gc:drawRect(self.x, self.y, self.width, 10)
	local y = self.y + 3
	local x = self.x + 2
	for _, btxt in pairs(self.cmtable) do
		gc:drawString(btxt.text, x, y, "middle")
		btxt.x = x
		btxt.y = y
		btxt.width = gc:getStringWidth(btxt.text)
		btxt.height = gc:getStringHeight(btxt.text) - 4
		x = x + 5 + btxt.width
	end
	if self.menOpen and not(self.parent.moveable) and self.parent.focused then
		gc:setColorRGB(unpack(color.Bdark))

		--dynamicly determine the width of the opened menu
		local dynwidth = 0
		local dynhold = 0
		for i = 1, table.maxn(self.selectedMenu.list) do
			dynhold = gc:getStringWidth( self.selectedMenu.list[i].text)
			if dynhold > dynwidth then
				dynwidth = dynhold
			end
		end
		local bx = self.selectedMenu.x
		local by = self.y + 10
		local bwidth = dynwidth + 5
		local bheight = gc:getStringHeight("HSS") * table.maxn(self.selectedMenu.list)
		gc:fillRect(bx, by, bwidth, bheight)
		gc:setColorRGB(unpack(color.black))
		gc:drawRect(bx, by, bwidth, bheight)
		local x = bx + 1
		local y = by + 6
		gc:setColorRGB(unpack(color.white))
		local heightfstring = gc:getStringHeight("HIS")
		for i = 1, table.maxn(self.selectedMenu.list) do
			gc:drawString(self.selectedMenu.list[i].text, x, y, "middle")
			self.selectedMenu.list[i].x = x
			self.selectedMenu.list[i].y = y
			self.selectedMenu.list[i].width = gc:getStringWidth(self.selectedMenu.list[i].text)
			self.selectedMenu.list[i].height = heightfstring
			y = y + heightfstring
		end
	else
		self.menOpen = false
	end
end
function contextm:checkClick(x, y)
	for _, item in pairs(self.cmtable) do
		if x >= item.x and x <= item.x + item.width and y >= item.y and y <= item.y + item.height - 4 and self.selectedMenu ~= nil and self.selectedMenu == item then
			self.menOpen = not(self.menOpen)
		elseif x >= item.x and x <= item.x + item.width and y >= item.y and y <= item.y + item.height and self.selectedMenu ~= nil and self.selectedMenu ~= item then
			self.selectedMenu = item
			self.menOpen = true
		elseif x >= item.x and x <= item.x + item.width and y >= item.y and y <= item.y + item.height and self.selectedMenu == nil then
			self.menOpen = true
			self.selectedMenu = item
		end
	end
	if self.menOpen then
		for _, item in pairs(self.selectedMenu.list) do
			if x >= item.x and x <= item.x + item.width and y >= item.y and y <= item.y + item.height then
				item:action()
				self.menOpen = false
				self.selectedMenu = nil
			end
		end
	end
end
