--these are dialogs. they offer multiline text but you cant have a control in them yet. V3 will offer places for up to 4 controls
dialog = class()

function dialog:init( x, y, text, title, backcolor, textcolor, isdrawn, parent, selected)--add buttons and other features
	self.titlex = x
	self.titley = y
	self.text = text
	self.title = title
	self.titlewidth = 200
	self.titleheight = 20
	self.x = self.titlex + 1
	self.y = self.titley + 20
	self.height = 156
	self.width = self.titlewidth - 2
	self.cbw = 5
	self.cbh = 5
	self.cbx = self.titlex + (self.width / 2)
	self.cby = self.titley + 6
	self.selected = selected
	self.backcolor = backcolor
	self.textcolor = textcolor
	self.isdrawn = isdrawn
	self.moveable = false
	self.parent = parent
	table.insert(parent.dialogs, self)
end
function dialog:paint(gc)
	if self.isdrawn then
		gc:setFont("sansserif", "b", 6)
		gc:setColorRGB(unpack(self.backcolor))
		gc:fillRect( self.titlex, self.titley, self.titlewidth, self.height)
		gc:setColorRGB(unpack(color.Bcontrol))
		gc:fillRect( self.x, self.y, self.width, self.height - 22)
		gc:setColorRGB(unpack(self.textcolor))
		if string.len(self.title) > 10 then
			self.title = string.sub(self.title, 1, 10).."..."
		end
		gc:drawString(self.title, self.titlex + 4, self.titley + 8, "middle")
		if string.find(self.text, "~") ~= nil then
			local offset = gc:getStringHeight(self.text) + 1
			local hold = {}
			hold = string.split(self.text, "~")
			gc:drawString(hold[1], self.x + 2, self.y + 2, "middle")
			for i = 2, table.maxn(hold) do
				gc:drawString(hold[i], self.x + 2, self.y + offset, "middle")
				offset = offset + gc:getStringHeight(self.text)
			end
		else
			gc:drawString(self.text, self.x + 2, self.y + 5, "middle")
		end
		gc:setColorRGB(unpack(color.red))
		gc:fillArc( self.cbx, self.cby, self.cbw, self.cbh, 0, 360)
	end
end
function dialog:checkUnclick()
	self.moveable = false
	cursor.set("default")
	self.selected = false
	platform.window:invalidate()
end
function dialog:checkClick(x, y)
	if self.isdrawn then
		if (x >= self.cbx and x <= self.cbx + 5) and (y >= self.cby and y <= self.cby + 5) then
			self:close()
		elseif self.moveable == false and (x >= self.titlex and x <= self.titlex + self.titlewidth) and (y >=self.titley and y <= self.titley + 20) then
			self:wasclicked(x, y)
		else
			self:checkUnclick()
		end
	end
end
function dialog:close()
	self.selected = false
	self.isdrawn = false
	self.moveable = false
	cursor.set("default")
end
function dialog:wasclicked(x, y)
	self.moveable = true
	if self.selected ~= self then
		for _, dlg in pairs(self.parent.dialogs) do
			dlg.selected = false
		end
		self.selected = true
	end
	self.xvar = x - self.titlex
	self.yvar = y - self.titley
	cursor.set("drag grab")
end
function dialog:mouseMove(x, y)
	if self.moveable and self.isdrawn and self.selected then
		cursor.set("drag grab")
		self.titlex = x - self.xvar
		self.titley = y - self.yvar
		self.cbx = self.titlex + (self.titlewidth / 2)
		self.cby = self.titley + 6
		self.x = self.titlex + 1
		self.y = self.titley + 20
		I()
	end
end
