--These are RadioButtons. They are almost complete, i kind of just want to change the look befor V3
radioButton = class()

function radioButton:init( text, x, y, marked, backcolor, markcolor, txtcolor, parent)
	self.text = text
	self.x = x + parent.x
	self.y = y + parent.y
	self.xoff = x
	self.yoff = y
	self.marked = marked
	self.parent = parent
	self.backcolor = backcolor
	self.markcolor = markcolor
	self.txtcolor = txtcolor
	self.height = 10
	self.width = 10
	table.insert(parent.controls, self)
end

function radioButton:paint(gc)
	gc:setColorRGB(unpack(self.backcolor))
	gc:fillArc( self.x, self.y, self.width, self.height, 0, 360)
	if self.marked then
		gc:setColorRGB(unpack(self.markcolor))
		gc:fillArc( self.x+2, self.y+2, 5, 5, 0, 360)
	else
		gc:setColorRGB(unpack(color.white))
		gc:fillArc( self.x+2, self.y+2, 5, 5, 0, 360)
	end
	gc:setColorRGB(unpack(self.txtcolor))
	gc:setFont( "sansserif", "r", 9)
	gc:drawString(self.text, self.x + 15, self.y, "middle")
end
function radioButton:click()
	if self.marked then
		self.marked = false
	else
		for _, rd in pairs(self.parent.controls) do
			rd.marked = false
		end
		self.marked = true
	end
end
function radioButton:checkClick(x, y)
	if (y >= self.y and y <= (self.y + self.height)) and (x >= self.x and (x <= self.x + self.width)) then
		self:click()
	end
end
