--This is the textboxes. the dt field i want to remove and have real scrolling text, that will probably come in V3
textbox = class()

function textbox:init(x, y, text, textcolor, tbcolor, parent, selected)
	self.parent = parent
	self.x = x + parent.x
	self.y = y + parent.y
	self.xoff = x
	self.yoff = y
	self.width = 156
	self.height = 20
	self.dt = {"", "", "", "", "", "", "", "", "", "", tabind = {}}
	self.di = 1
	self.dt[1] = text
	self.text = text
	self.textcolor = textcolor
	self.tbcolor = tbcolor
	self.selected = selected
	self.cury = self.y + 1
	self.curx = self.x + 1
	self.curh = (self.y + self.height) - 1
	self.parent = parent
	self.type = "txt"
	self.stwid = 0
	table.insert(parent.controls, self)
end
function textbox:paint(gc)
	gc:setColorRGB(unpack(self.tbcolor))
	self.dt.tabind = gc:getStringWidth("")
	gc:drawRect( self.x, self.y, self.width, self.height)
	gc:setColorRGB(unpack(self.textcolor))
	gc:setFont("sansserif", "r", 11)
	self.stwid = gc:getStringWidth(self.dt[self.di])
	gc:drawString( self.dt[self.di], self.x + 4, self.y + 8, "middle")
	gc:setColorRGB(unpack(color.black))
	self.cury = self.y + 1
	self.curx = self.x + self.stwid + 3
	self.curh = (self.y + self.height) - 1
	gc:drawLine(self.curx, self.cury, self.curx, self.curh)
end
function textbox:charIn(ch)
	if self.selected then
		if (self.width - 8) <= self.stwid then
			if self.di ~= 10 then
				self.di = self.di + 1
				self.dt[self.di] = self.dt[self.di]..ch
				self.text = self.text..ch
			end
		else
			self.dt[self.di] = self.dt[self.di]..ch
			self.text = self.text..ch
		end
	end
	platform.window:invalidate(self.x, self.y, self.width, self.height)
end
function textbox:backspaceKey()
	if self.curx == self.x + self.dt.tabind + 3 and self.di ~= 1 then
		self.di = self.di - 1
	else
		self.dt[self.di] = string.sub(self.dt[self.di], 1, string.len(self.dt[self.di]) - 1)
		self.text = string.sub(self.text, 1, string.len(self.text) - 1)
	end
	platform.window:invalidate(self.x, self.y, self.width, self.height)
end

function textbox:click()
	if self.selected then
		self.selected = false
	else
		for _, tb in pairs(self.parent.controls) do
			if tb.type == "txt" then
				tb.selected = false
			end
		end
		self.selected = true
	end
end
function textbox:checkClick(x, y)
	if y >= self.y and y <= self.y + self.height and x >= self.x and x <= self.x + self.width then
		self:click()
	end
end
